#include "test_xxint.h"
//#include "options/File_Path.h"
using std::string;

using CuTe::test_CS;
using std::cerr;
using std::cout;
using std::endl;
using std::vector;
using std::ofstream;
using std::stringstream;

using namespace CuTe::NS_enums::NS_RES;
using NS_File_Path::File_Path;

bool plot(CuTe::SOPS_CuTe &OP,NS_File_Path::File_Path infile){
	cout	<<"Infile: "<<infile<<endl;
	cout	<<"Folder: "<<infile.dir<<endl;

	if(!OP.Plot.y.is_set){
		cerr	<<"y not set:"<<endl;
		return 1;
	}

	RES res = OP.Scheme.resummation();

//	switch (res) {
//		case RES_MATCHED:
//		case RES_MATCHING_CORR:
//		case RES_RES_CORR:
//			cerr	<<"Wrong res:"<<res<<endl;
//			return 1;
//			break;
//		default:
//			break;
//	}

	OP.CUBA.CUBA_cores.value = 0;

	vector<double> qT(OP.Plot.qT());
	vector<double> y(OP.Plot.y());

	using CuTe::NS_Utils::operator <<;
	cout <<"qT:"<<qT<<endl;
	cout <<"y:"<<y<<endl;


	size_t N=15;

	test_CS CS;

	CS.init(N,OP);

	ofstream of;
	File_Path ofname;

	CuTe::NS_Utils::Timer timer;

	cout	<<"OF\tsec.\tqT\ty\tresult\terror"<<endl;
	for(int i=0; i<qT.size(); ++i) for(int j=0; j<y.size(); ++j){
//		CuTe::NS_Utils::DOUT dout("loop");
		stringstream namestream;
		namestream<<OP.Process.prod()<<"_"<<res<<"_"<<OP.CUBA.CUBA_routine()<<"_qT"<<qT[i]<<"_y"<<y[j];
		ofname = File_Path(infile.dir,namestream.str(),"out");

		timer.start();
		CS.update_qT_y(qT[i],y[j]);
		timer.stop();

		cout	<<ofname.file<<"\t"<<timer<<"\t"<<qT[i]<<"\t"<<y[j]<<"\t"<<CS.results22[0]<<"\t"<<CS.results22[1]<<endl;

		of.open(ofname.full.c_str());
		CS.xx_to_stream(of);
		of.close();
	}

	return 0;
}

int main (int argc, char *argv[]){

	string filename;
	CuTe::SOPS_CuTe OP;

	if(argc>=2){
		for(int i=1; i<argc; ++i){
			filename = argv[i];
			cout << "argv[" << i << "] = " << argv[i] << endl;
			if(OP.open(filename)){
				plot(OP,filename);
			}
		}
	}else{
		cout << " ! NO FILE ARGUMENT ! " << endl;
		filename="test.in";
		if(OP.open(filename)){
			plot(OP,filename);
		}
	}



	return 0;
}
